/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.antrax.storage.commons.impl.CallAllocationAlgorithm;
import com.flamesgroup.antrax.storage.commons.impl.SmsAllocationAlgorithm;
import com.flamesgroup.storage.convert.CallAllocationAlgorithmConverter;
import com.flamesgroup.storage.convert.SmsAllocationAlgorithmConverter;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.RouteConfigRecord;

import java.util.Arrays;
import java.util.List;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class RouteConfig extends TableImpl<RouteConfigRecord> {

	private static final long serialVersionUID = -1956264480;

	/**
	 * The reference instance of <code>public.route_config</code>
	 */
	public static final RouteConfig ROUTE_CONFIG = new RouteConfig();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<RouteConfigRecord> getRecordType() {
		return RouteConfigRecord.class;
	}

	/**
	 * The column <code>public.route_config.id</code>.
	 */
	public final TableField<RouteConfigRecord, Long> ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.route_config.call_allocation_algorithm</code>.
	 */
	public final TableField<RouteConfigRecord, CallAllocationAlgorithm> CALL_ALLOCATION_ALGORITHM = createField("call_allocation_algorithm", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "", new CallAllocationAlgorithmConverter());

	/**
	 * The column <code>public.route_config.sms_allocation_algorithm</code>.
	 */
	public final TableField<RouteConfigRecord, SmsAllocationAlgorithm> SMS_ALLOCATION_ALGORITHM = createField("sms_allocation_algorithm", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "", new SmsAllocationAlgorithmConverter());

	/**
	 * Create a <code>public.route_config</code> table reference
	 */
	public RouteConfig() {
		this("route_config", null);
	}

	/**
	 * Create an aliased <code>public.route_config</code> table reference
	 */
	public RouteConfig(String alias) {
		this(alias, ROUTE_CONFIG);
	}

	private RouteConfig(String alias, Table<RouteConfigRecord> aliased) {
		this(alias, aliased, null);
	}

	private RouteConfig(String alias, Table<RouteConfigRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<RouteConfigRecord, Long> getIdentity() {
		return Keys.IDENTITY_ROUTE_CONFIG;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<RouteConfigRecord> getPrimaryKey() {
		return Keys.ROUTE_CONFIG_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<RouteConfigRecord>> getKeys() {
		return Arrays.<UniqueKey<RouteConfigRecord>>asList(Keys.ROUTE_CONFIG_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public RouteConfig as(String alias) {
		return new RouteConfig(alias, this);
	}

	/**
	 * Rename this table
	 */
	public RouteConfig rename(String name) {
		return new RouteConfig(name, null);
	}
}
